post:
    description: Create track
    body:
        application/json:
            example: !include post-request-example.json
            type: !include post-request-schema.json
    responses:
        201:
            body:
                application/json:
                    type: !include post-response-201-schema.json
                    example: !include post-response-201-example.json
        409:
            body:
                application/json:
                    type: !include post-response-409-schema.json
                    example: !include post-response-409-example.json
get:
    description: Tracks catalog
    is: [paginated, sorted]
    queryParameters:
        id?:
            description: ID of the track to search
            type: number
            minimum: 1
            example: 1
        title?:
            description: Title of the track to search
            type: string
            maxLength: 120
            example: Intense
        artist?:
            description: Artist of the track to search
            type: string
            maxLength: 120
            example: Miri Ben-Ari
        isrc?:
            description: International Standard Recording Code of the track to search
            type: string
            pattern: ^[A-Z]{2}[A-Z0-9_]{3}[0-9]{2}[0-9]{5}$
            minLength: 12
            maxLength: 12
            example: ABC123456789
        genre?:
            description: Genre of the track to search
            type: string
            example: TRANCE
        albumId?:
            description: Album of the track to search
            type: number
            minimum: 1
            example: 1
        userId?:
            description: User of the track to search
            type: number
            minimum: 1
            example: 1
        status?:
            description: Status of the track to search
            type: boolean
            default: false
            example: true
    responses:
        200:
            body:
                application/json:
                    type: !include get-response-200-schema.json
                    example: !include get-response-200-example.json

/{id}:
    uriParameters: 
        id: 
            type: integer
            default: 1
            minimum: 1
            description: The `id` parameter to search track.
            example: 1
    get:
        description: Track detail
        responses:
            200:
                body:
                    application/json:
                        type: !include id/get-response-200-schema.json
                        example: !include id/get-response-200-example.json
            404:
                body:
                    application/json:
                        type: !include id/get-response-404-schema.json
                        example: !include id/get-response-404-example.json
    patch:
        description: Track update
        body:
            application/json:
                example: !include id/patch-request-example.json
                type: !include id/patch-request-schema.json
        responses:
            200:
                body:
                    application/json:
                        type: !include id/patch-response-200-schema.json
                        example: !include id/patch-response-200-example.json
            404:
                body:
                    application/json:
                        type: !include id/patch-response-404-schema.json
                        example: !include id/patch-response-404-example.json
            409:
                body:
                    application/json:
                        type: !include id/patch-response-409-schema.json
                        example: !include id/patch-response-409-example.json
    delete:
        description: Track delete
        responses:
            200:
                body:
                    application/json:
                        type: !include id/delete-response-200-schema.json
                        example: !include id/delete-response-200-example.json
            404:
                body:
                    application/json:
                        type: !include id/delete-response-404-schema.json
                        example: !include id/delete-response-404-example.json